unit mdiedit;

(***************************************)
(* Copyright (C) 2003, SHIRAISHI Kazuo *)
(***************************************)


interface

uses QTypes, Qclipbrd, Classes, QGraphics, QForms, QControls, QMenus,
  QStdCtrls, QDialogs, SysUtils, QPrinters, QExtCtrls, QComCtrls,
  QButtons ;

type
  TEditForm = class(TForm)

    MainMenu1: TMainMenu;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    SelectAll1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    N3: TMenuItem;
    Close1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;

    Run1: TMenuItem;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    Find1: TMenuItem;
    Repalce1: TMenuItem;
    FindNext1: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    ToolBox1: TMenuItem;
    N7: TMenuItem;
    WordWrap1: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    Search1: TMenuItem;
    N8: TMenuItem;
    About1: TMenuItem;
    Break1: TMenuItem;
    Run2: TMenuItem;
    N4: TMenuItem;
    Undo1: TMenuItem;
    deleteLabelNumber1: TMenuItem;
    merge1: TMenuItem;
    Memo1: TMemo;
    PopupMenu1: TPopupMenu;
    popupRun1: TMenuItem;
    Popupstep1: TMenuItem;
    N12: TMenuItem;
    Cut2: TMenuItem;
    copy2: TMenuItem;
    paste2: TMenuItem;
    Delete2: TMenuItem;
    SelectAll2: TMenuItem;
    N15: TMenuItem;
    step1: TMenuItem;
    PopUpBreak1: TMenuItem;
    N1: TMenuItem;
    Trace1: TMenuItem;
    AddLabelNumber1: TMenuItem;
    N10: TMenuItem;
    CaseChange1: TMenuItem;
    N9: TMenuItem;
    Commentize1: TMenuItem;
    UnCommentize1: TMenuItem;

    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure OpenFile(FileName: string);
    procedure Save1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Run2Click(Sender: TObject);
    procedure WordWrap1Click(Sender: TObject);
    procedure Break1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure Repalce1Click(Sender: TObject);
    procedure FindNext1Click(Sender: TObject);
    procedure Find(Sender: TObject);
    procedure Replace(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    //procedure Option1Click(Sender: TObject);
    //procedure Font1Click(Sender: TObject);
    //procedure option2Click(Sender: TObject);
    procedure step1Click(Sender: TObject);
    procedure ToolBox1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure Search1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure deleteLabelNumber1Click(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure merge1Click(Sender: TObject);
    procedure SelectAll2Click(Sender: TObject);
    procedure Popupstep1Click(Sender: TObject);
    procedure Cut2Click(Sender: TObject);
    procedure copy2Click(Sender: TObject);
    procedure paste2Click(Sender: TObject);
    procedure Delete2Click(Sender: TObject);
    procedure popupRun1Click(Sender: TObject);
    procedure PopUpBreak1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure AddLabelNumber1Click(Sender: TObject);
    procedure CaseChange1Click(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UnCommentize1Click(Sender: TObject);
    procedure Commentize1Click(Sender: TObject);
  private
     executing:boolean;
     OverWriteMode:boolean;
     searchLength:integer;
    function search(const FText:ansistring; Options:TFindOptions):boolean;
    function curText:ansistring;
    procedure UpdateCursorPos;
    procedure PrepareSearch;
    procedure AutoFormat;
    function SaveAs:boolean;
    function Save:boolean;
    procedure Commentize(f:boolean);
  public
     backup:ansistring;
     UnDoFromBackUp:boolean;
     AngleConfirmed:boolean;
     ArithmeticConfirmed:boolean;
  end;

var
   DefaultEditForm:TEditForm;



implementation
uses Types,  Qt,
     mdiframe, myutils,base,compiler,optiondg,helpctex,toolfrm,
     texthand,kwlist,findtext,struct,afdg,sconsts, about, printdlg;

{$R *.xfm}


procedure TEditForm.New1Click(Sender: TObject);
begin
  FrameForm.OpenTextFile('');
end;

procedure TEditForm.OpenFile(FileName: string);
begin
      Memo1.Lines.LoadFromFile(FileName);
      Memo1.Modified:=false;
      Caption := FileName;
end;

procedure TEditForm.Open1Click(Sender: TObject);
begin
  FrameForm.Open1Click(Sender);
end;

function TEditForm.Save:boolean;
begin
  if (Caption = '') or (Pos('NoName',Caption)>0 )then
    result:=SaveAs
  else
  begin
    Memo1.Lines.SaveToFile(Caption);
    Memo1.Modified := false;
    result:=true;
  end;
end;

procedure TEditForm.Save1Click(Sender: TObject);
begin
   save;
end;


function TEditForm.SaveAs:boolean;
begin
  With FrameForm.SaveDialog1 do
  begin
     Filter:=s_program+'|*'+BasExt+'|'+s_library+'|*'+LibExt+'|'+s_TextFile+'|*.TXT';
     FileName := Self.Caption;
     DefaultExt:=copy(BasExt,2,3);
     result:=Execute;
     if result then
     begin
      self.Caption := FileName;
      result:=Save;
     end;
  end;
end;

procedure TEditForm.SaveAs1Click(Sender: TObject);
begin
   SaveAs
end;

procedure TEditForm.Exit1Click(Sender: TObject);
begin
  FrameForm.Close1Click(Sender);
end;

procedure TEditForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TEditForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  MsgVal: integer;
  FileName: string;
begin
  if executing then
     begin
      //ShowMessage(s_CannotQuit);
      Break1Click(Sender);
      CanClose:=false;
      exit
     end
  else
     begin
        FileName := Caption;
        if Memo1.Modified then
         begin
          MsgVal := MessageDlg(Format(CloseMsg, [FileName]),
                    mtConfirmation, [mbYes,mbNo,mbCancel], 0);
          case MsgVal of
            mrYes: CanClose:=Save;
            mrCancel: CanClose := false;
          end;
        end;
     end;   
end;

(*
procedure TEditForm.Cut1Click(Sender: TObject);
var
  svselStart,svSelLen:integer;
  h:QMultiLineEditH;
begin
  if executing then exit;
  if FaultyCut then
     begin
       svSelStart:=memo1.SelStart;
       svSelLen:=memo1.SelLength;
     end;
  clipboard.astext:=memo1.seltext;
  if FaultyCut then
     begin
       memo1.SelStart:=svSelStart;
       Memo1.SelLength:=svSelLen;
     end;
  memo1.seltext:='';
  UnDoFromBackUp:=false;
end;

procedure TEditForm.Copy1Click(Sender: TObject);
begin
  clipboard.astext:=memo1.seltext;
  UnDoFromBackUp:=false;
end;

procedure TEditForm.Paste1Click(Sender: TObject);
begin
  if executing then exit;
  memo1.seltext:=clipboard.astext;
  UnDoFromBackUp:=false;
end;

procedure TEditForm.Delete1Click(Sender: TObject);
begin
  if executing then exit;
  Memo1.ClearSelection;
  UnDoFromBackUp:=false;
end;
*)

procedure TEditForm.Cut1Click(Sender: TObject);
begin
  if executing then exit;
  QMultiLineEdit_cut(Memo1.Handle);
  UnDoFromBackUp:=false;
end;

procedure TEditForm.Copy1Click(Sender: TObject);
begin
  QMultiLineEdit_copy(Memo1.Handle);
  UnDoFromBackUp:=false;
end;

procedure TEditForm.Paste1Click(Sender: TObject);
begin
  if executing then exit;
  QMultiLineEdit_paste(Memo1.Handle);
  UnDoFromBackUp:=false;
end;

procedure TEditForm.Delete1Click(Sender: TObject);
begin
  if executing then exit;
  Memo1.ClearSelection;
  UnDoFromBackUp:=false;
end;

procedure TEditForm.SelectAll1Click(Sender: TObject);
begin
  Memo1.SelectAll;
end;


procedure TEditForm.Print1Click(Sender: TObject);
begin
   PrintDialog.Execute(memo1);
end;

procedure TEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
      Action := caFree;
end;






procedure TEditForm.WordWrap1Click(Sender: TObject);
begin
  with Memo1 do begin
    WordWrap := not WordWrap;
    if WordWrap then
      ScrollBars := ssVertical
    else
      ScrollBars := ssBoth;
    WordWrap1.Checked := WordWrap;
  end;
end;

procedure TEditForm.PrepareSearch;
var
  s:string;
begin
  s:=Memo1.seltext;
  if MultiLine(s) then
     SearchLength:=Memo1.sellength-1
  else
     begin
        SearchLength:=Length(Memo1.text)-1;
        memo1.selstart:=0;
        FindDialog1.FindText:=s;
        ReplaceDialog1.FindText:=s;
     end;
  Memo1.sellength:=0;
end;

procedure TEditForm.Find1Click(Sender: TObject);
begin
  PrepareSearch;
  FindDialog1.Execute;
  FindNext1.Enabled := True;
end;

procedure TEditForm.Repalce1Click(Sender: TObject);
begin
  if executing then exit;
  backUp:=Memo1.lines.text;
  UnDoFromBackUp:=true;

  PrepareSearch;
  ReplaceDialog1.Execute;
  FindNext1.Enabled := False;
end;

procedure TEditForm.FindNext1Click(Sender: TObject);
begin
  Find(FindDialog1);
end;

function TEditForm.search(const FText:ansistring; Options:TFindOptions):boolean;
var
   p:integer;
   s:TFindOptions;
   InitialPos:integer;
begin
  s:=[];
  if frMatchCase in Options then s:=s+[frMatchCase];
  with memo1 do
        begin
          InitialPos:=selstart+selLength;
          if frWholeWord in Options then
             p:=findword(memo1,FText,InitialPos,SearchLength,s)
          else
             //p:=findtext(FText,InitialPos,SearchLength,s);
             p:=SearchText(memo1,FText,InitialPos,SearchLength,s);
          if p>=0 then
            begin
               selstart:=p;
               selLength:=length(FText);
               result:=true;
               searchLength:=searchlength-(p-initialPos)-SelLength;
            end
          else
             begin
               result:=false;
               selStart:=SelStart+selLength;
               selLength:=0;
             end;  
        end;
end;

procedure TEditForm.Find(Sender: TObject);
begin
  with Sender as TFindDialog do
    if Search( FindText, Options) then
    else
       ShowMessage( FindText + EOL+ s_NotFound);
end;

procedure TEditForm.Replace(Sender: TObject);
var
  Found: Boolean;
begin
  with ReplaceDialog1 do
  begin
    if AnsiCompareText(Memo1.SelText, FindText) = 0 then
      Memo1.SelText := ReplaceText;
    Found := Search( FindText, Options);
    while Found and (frReplaceAll in Options) do
    begin
      Memo1.SelText := ReplaceText;
      Found := Search( FindText, Options);
    end;
    if (not Found) {and (frReplace in Options)} then
       //CloseDialog //ShowMessage( FindText + EOL+ s_NotFound);
  end;
end;

procedure TEditForm.FindDialog1Find(Sender: TObject);
begin
     Find(Sender);
end;

procedure TEditForm.ReplaceDialog1Find(Sender: TObject);
begin
      Find(Sender)
end;

procedure TEditForm.ReplaceDialog1Replace(Sender: TObject);
begin
    Replace(Sender);
end;

procedure TEditForm.FormCreate(Sender: TObject);
begin

     Memo1.Font.Assign(EditorFont);
     Windowstate:=wsMaximized;
     Break1.ShortCut:=ShortCut(Word(BreakKey), [ssCtrl]);
     executing:=false;
     OverWriteMode:=false;
     if ExecutingNow then
        begin
                        Run2.enabled:=false;
                        Break1.enabled:=true;
                        Step1.enabled:=false;
                        Exit1.enabled:=false;
                        PopUpRun1.enabled:=false;
                        PopUpBreak1.enabled:=true;
                        PopUpStep1.enabled:=false;
        end;

end;


procedure TEditForm.ToolBox1Click(Sender: TObject);
begin
    if not memo1.ReadOnly then
       try
           ToolFrm.ToolBox.show
       except
            showmessage('System Error')
       end;
end;

procedure TEditForm.Contents1Click(Sender: TObject);
begin
     Application.KeywordHelp('');
     //  Application.HelpCommand(HELP_FINDER,0)
end;

procedure TEditForm.Search1Click(Sender: TObject);
var
    s:shortstring;
begin
    s:=Trim(Memo1.SelText);
    if s='' then s:=(curText);
    if s<>'' then
       begin
         //s:=s+chr(0);
         Application.KeywordHelp(s)
         //Application.HelpCommand(HELP_PARTIALKEY,LongInt(@s[1]))
       end
    else
        Contents1Click(Sender)
end;

procedure TEditForm.FormActivate(Sender: TObject);
begin
    if toolfrm.toolbox<>nil then toolfrm.ToolBox.setreff(self)  ;
    FrameForm.setStatusBar1(OverWriteMode);
    with FrameForm do
      begin
        TBCut.enabled:=not executing;
        TBPaste.enabled:=not executing;
        TBUndo.enabled:=not executing;
      end;
       UpdateCursorPos ;

end;

procedure TEditForm.About1Click(Sender: TObject);
begin
      AboutBox.ShowModal
end;

procedure TEditForm.Run2Click(Sender: TObject);
begin
   backup:=memo1.lines.text;
   UnDoFromBackUp:=true;
   executing:=true;
   RunNormal(self);
   executing:=false;
end;

procedure TEditForm.step1Click(Sender: TObject);
begin
   backup:=memo1.lines.text;
   UnDoFromBackUp:=true;
   executing:=true;
   RunStep(self);
   executing:=false;
end;

procedure TEditForm.Break1Click(Sender: TObject);
begin
    CtrlBreakHit:=true;
    FrameForm.SetBreakMessage;
end;


procedure TEditForm.FormDestroy(Sender: TObject);
begin
    if self=DefaultEditForm then
       DefaultEditForm:=nil
end;


procedure TEditForm.Undo1Click(Sender: TObject);
begin
    if UnDoFromBackup then
      memo1.lines.text:=backUp
    else
      QMultiLineEdit_undo(Memo1.Handle);
      //SendMessage(Memo1.Handle,WM_UNDO,0,0);
end;


procedure TEditForm.deleteLabelNumber1Click(Sender: TObject);
begin
      backup:=memo1.lines.text;
      UndoFromBackUp:=true;
      deleteLabelNumber(memo1)
end;

procedure TEditForm.FormDeactivate(Sender: TObject);
begin
    //FindDialog1.closeDialog;
    //ReplaceDialog1.closeDialog;

end;

procedure TEditForm.merge1Click(Sender: TObject);
var
  t:TEditForm;
begin
  FrameForm.OpenDialog1.Filter :=
        s_Library+'|*.lib|'+s_Program+'|*.bas|'+s_TextFile+'|*.txt';
  FrameForm.OpenDialog1.DefaultExt := 'lib';
  if FrameForm.OpenDialog1.Execute then
     begin
        memo1.modified:=true;
        t:=FrameForm.OpenTextFile(FrameForm.OpenDialog1.FileName);
        memo1.lines.addstrings(t.memo1.lines);
        t.close;
     end;
end;

procedure TEditForm.SelectAll2Click(Sender: TObject);
begin
     SelectAll1Click(Sender)
end;

procedure TEditForm.Popupstep1Click(Sender: TObject);
begin
     step1Click(Sender)
end;

procedure TEditForm.Cut2Click(Sender: TObject);
begin
    Cut1Click(Sender)
end;

procedure TEditForm.copy2Click(Sender: TObject);
begin
       copy1Click(Sender)
end;

procedure TEditForm.paste2Click(Sender: TObject);
begin
     paste1Click(sender)
end;

procedure TEditForm.Delete2Click(Sender: TObject);
begin
     Delete1Click(Sender)
end;

procedure TEditForm.popupRun1Click(Sender: TObject);
begin
       Run2Click(Sender)
end;

procedure TEditForm.PopUpBreak1Click(Sender: TObject);
begin
    break1Click(Sender)
end;

procedure TEditForm.Edit1Click(Sender: TObject);
var
   b:boolean;
begin
    b:= memo1.seltext<>'' ;
    with cut1 do enabled:=(not executing) and b;
    //copy1.enabled:=b;
    with delete1 do enabled:=(not executing) and b;
    paste1.Enabled:=not executing;
end;

procedure TEditForm.PopupMenu1Popup(Sender: TObject);
var
   b:boolean;
begin
    b:= memo1.seltext<>'' ;
    cut2.enabled:=(not executing) and b;
    copy2.enabled:=b;
    delete2.enabled:=(not executing) and b;
    paste2.enabled:=(not executing) ;
end;


const
   KeyWordChar:set of char=['0'..'9','A'..'Z','a'..'z','$','_'];
   PunctuationChar:set of char=[#13,#10,' ','&'..'/',':'..'>','^'];

function bytechar(s:WideString):char;
var
  t:string;
begin
  t:=s;
  result:=#0;
  if length(t)>0 then result:=t[1]
end;

function TEditForm.curText:ansistring;
var
   i,j:integer;
   s:widestring;
begin
    result:='';
    i:=memo1.selstart +1;
    j:=i;
    s:=memo1.text;
    while (i>1) and (bytechar(s[i-1]) in KeyWordChar) do dec(i);
    while bytechar(s[j]) in KeyWordChar do inc(j);
    result:=copy(s,i,j-i)
end;

procedure TEditForm.FormResize(Sender: TObject);
begin
   memo1.refresh;
end;

procedure TEditForm.AddLabelNumber1Click(Sender: TObject);
begin
      backup:=memo1.lines.text;
      UndoFromBackUp:=true;
      AddLabelNumber(memo1);
end;

procedure TEditForm.CaseChange1Click(Sender: TObject);
begin
      backup:=memo1.lines.text;
      UndoFromBackUp:=true;
      CaseChange(memo1);
end;

procedure TEditForm.Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

  procedure insert(const s:string);
     begin
         backUp:=Memo1.lines.Text;
         Memo1.seltext:=s;
         Memo1.SelStart:=Memo1.SelStart+length(s);
         Memo1.SelLength:=0;
         UndoFromBackUp:=true;
     end;

var
   column,s:integer;
begin

   if key=Key_Tab then
   with Memo1 do
   begin
      column:=CaretPos.Col;
      if column<24 then
         s:=3 - (column mod 3)
      else
         s:= 6 - (column mod 6);
      seltext:=copy('      ',1,s) ;
      selstart:=selstart+s;
      key:=0;
    end;


  if (shift=[]) then
    case Key of
      key_F1:begin
             Search1Click(Sender);
             key:=0;
            end;
    end
  else if  (shift=[ssshift]) and (memo1.ReadOnly=false) then
    case Key of
      key_F5:insert(shift_F5);
      key_F6:insert(shift_F6);
      key_F7:insert(shift_F7);
      key_F8:insert(shift_F8);
    end ;

end;

procedure TEditForm.Memo1KeyUp(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
   if Memo1.sellength=0 then
      begin
         UpdateCursorPos;
         if not ExecutingNow and AutoFormatKw then
                             AutoFormat;
      end;                       
end;

procedure TEditForm.UpdateCursorPos;
var
  CPos: TCaretPos;
begin
  if  executing then  exit;

  CPos:=Memo1.CaretPos;
  Inc(CPos.line);
  Inc(CPos.col);
  FrameForm.StatusBar1.Panels[1].text:=Format('%6d:%4d', [CPos.line, CPos.col]);
  //FrameForm.StatusBar1.Panels[1].Bevel:=pbLowered;
end;

var PrevIndex:integer=0;
procedure TEditForm.AutoFormat;
var
   i,j:integer;
begin
  if  executing then exit;
  if TextHand.memo<>nil then exit; //ɻ

  //LockWindowUpdate(Memo1.Handle);

  j:=PrevIndex;
  PrevIndex:=Memo1.SelStart;
  if  (j>0)
       and (length(Memo1.lines.Text)>j)
       and (Memo1.lines.text[j] in KeyWordChar )
       and (Memo1.lines.text[j+1] in PunctuationChar )
       and (Pass=0)
       {and (TextHand.memo=nil)} then
    begin
       memo1.lines.BeginUpdate;
       texthand.memo:=memo1;
       //texthand.linenumber:=SendMessage(memo1.handle,EM_LINEFROMCHAR,j,0);
       texthand.linenumber:=LineFromChar(memo1,j);
       try
         texthand.initline;
         while tokenspec<>tail do
            begin
               if tokenspec in [NIdf,SIdf] then
                  begin
                     if keyWordList1.find(token,i)
                        or ((token='ANGLE') and (PrevToken='OPTION'))
                        or ((token='SIZE') and (PrevToken='DEVICE'))
                        or  keyWordList2.find(token,i) then
                        ReplaceToken(token);
                  end;
               if (token='DATA') or (token='IMAGE') or (token='REM') then
                   skip
                   //while tokenspec<>tail do gettoken
               else
                   gettoken;
            end;
       except
         on e:exception do
       end;
       texthand.memo:=nil;
       Memo1.SelStart:= PrevIndex;
       memo1.lines.EndUpdate;
    end;
    //LockWindowUpdate(0);

end;


procedure TEditForm.Commentize1Click(Sender: TObject);
begin
   Commentize(true)
end;

procedure TEditForm.UnCommentize1Click(Sender: TObject);
begin
   Commentize(false)
end;

procedure TEditForm.Commentize(f:boolean);
var
   i,l1,l2,j:integer;
   s:string;
begin
  with Memo1 do
  begin
    l1:=selection.Line1;
    l2:=selection.Line2;
    if (selection.Col2=0) and (l2>l1) then dec(l2);
    for i:=l1 to l2 do
      begin
        s:=lines[i];
        if f then
           s:='!'+s
        else
           begin
             j:=1;
             while (j<=Length(s)) and (s[j]=' ') do inc(j);
             if (j<=Length(s)) and (s[j]='!')  then  delete(s,1,j)
           end;
        lines[i]:=s;
      end;
  end;
end;


end.

